# dxforward.py version 0.1
#
# dxspider to email message forwarder
# (C) 2016, I8ZSE Giorgio L. Rutigliano, giorgio@i8zse.eu
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# see <http://www.gnu.org/licenses/>.

import smtplib
import sys
from email.mime.text import MIMEText
import datetime

#constants and configuration
SMTPSERVER='<smtp server>'
SMTPUSER='<username>'
SMTPPASS='<userpass>'
FROM='<from address>'
TO='<recipient address>'
SUBJ='Received a new message on dxcluster'
CALL='<sysop call>'

def send_msg(frm,to,subj,testo):
    """send an email message via smtp server"""
    res=[0,'ok']
    # costruisce il messaggio
    msg=MIMEText(testo)
    msg['Subject'] = subj
    msg['From'] = frm
    msg['To'] = to
    # invia il messaggio
    try:
        conn=smtplib.SMTP(SMTPSERVER)
        conn.set_debuglevel(False)
        conn.login(SMTPUSER, SMTPPASS)
        conn.sendmail(FROM, to, msg.as_string())
    except smtplib.SMTPException as e:
        res=[e.smtp_code,e.smtp_error]
    except Exception as e:
        res=[e.errno,e.strerror]
    finally:
        try:
           conn.close()
        except:
           pass
    return res

#read message index file
try:
  f=open('Msgno','r')
  nMsg=int(f.readline().strip())
  f.close
except:
  sys.exit(1)
#read last processed email file
try:
  f=open('Msgno.lst','r')
  lMsg=int(f.readline().strip())
  f.close
except:
  lMsg=0
#parse each new message 
for i in range(lMsg,nMsg):
  i+=1
  f=open('m'+str(i).zfill(6),'r')
  Msg=f.readlines()
  f.close()
  header=Msg[0].split('^')
  subject=Msg[1]
  body='DxCluster message\n'
  body+='From='+header[2]+' on '+header[6]+'\n'
  body+='Date='+datetime.datetime.fromtimestamp(float(header[3])).strftime('%Y-%m-%d %H:%M:%S')+'\n'
  body+='Subj='+header[5]+'\n'
  for row in Msg[3:]:
     body+=row
  #if recipient callsign matches, send email
  if (header[1]==CALL):
     send_msg(FROM, TO, SUBJ, body)
  #update processed message file
  f=open('Msgno.lst','w')
  f.write(str(i))
  f.close
